# Class VulkanMemoryType.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanMemoryType.Builder

Enclosing class:
  `VulkanMemoryType`

public static final class VulkanMemoryType.Builder extends Object
Builds instances of type `VulkanMemoryType`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanMemoryType.Builder`
  `addAllFlags(Iterable<VulkanMemoryPropertyFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanMemoryType.Builder`
  `addFlags(VulkanMemoryPropertyFlag element)`
  Adds one element to `flags` set.
  `final VulkanMemoryType.Builder`
  `addFlags(VulkanMemoryPropertyFlag... elements)`
  Adds elements to `flags` set.
  `VulkanMemoryType`
  `build()`
  Builds a new `VulkanMemoryType`.
  `final VulkanMemoryType.Builder`
  `from(VulkanMemoryTypeType instance)`
  Fill a builder with attribute values from the provided `VulkanMemoryTypeType` instance.
  `final VulkanMemoryType.Builder`
  `setFlags(Iterable<VulkanMemoryPropertyFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanMemoryType.Builder`
  `setHeapIndex(VulkanMemoryHeapIndex heapIndex)`
  Initializes the value for the `heapIndex` attribute.
  `final VulkanMemoryType.Builder`
  `setIndex(VulkanMemoryTypeIndex index)`
  Initializes the value for the `index` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanMemoryType.Builder from(VulkanMemoryTypeType instance)
    Fill a builder with attribute values from the provided `VulkanMemoryTypeType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setIndex

    public final VulkanMemoryType.Builder setIndex(VulkanMemoryTypeIndex index)
    Initializes the value for the `index` attribute.
    Parameters:
      `index` - The value for index
    Returns:
      `this` builder for use in a chained invocation

  - ### setHeapIndex

    public final VulkanMemoryType.Builder setHeapIndex(VulkanMemoryHeapIndex heapIndex)
    Initializes the value for the `heapIndex` attribute.
    Parameters:
      `heapIndex` - The value for heapIndex
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanMemoryType.Builder addFlags(VulkanMemoryPropertyFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanMemoryType.Builder addFlags(VulkanMemoryPropertyFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanMemoryType.Builder setFlags(Iterable<VulkanMemoryPropertyFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanMemoryType.Builder addAllFlags(Iterable<VulkanMemoryPropertyFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanMemoryType build()
    Builds a new `VulkanMemoryType`.
    Returns:
      An immutable instance of VulkanMemoryType
    Throws:
      `IllegalStateException` - if any required attributes are missing